#
# Conditional build:
%bcond_without	ocaml_opt	# skip building native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), update when upstream will support it
%ifnarch %{ix86} %{x8664} arm aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

%define		ocaml_ver	1:3.09.2
Summary:	CamlIDL - stub code generator and COM binding for OCaml
Summary(pl.UTF-8):	CamlIDL - generator kodu zaślepek oraz wiązania COM dla OCamla
Name:		ocaml-idl
Version:	1.05
Release:	11
License:	QPL v1.0 (compiler), LGPL v2 (library)
Group:		Libraries
Source0:	http://caml.inria.fr/distrib/bazar-ocaml/camlidl-%{version}.tar.gz
# Source0-md5:	4cfb863bc3cbdc1af2502042c45cc675
Source1:	http://caml.inria.fr/distrib/bazar-ocaml/camlidl-%{version}.doc.html.tar.gz
# Source1-md5:	b7c7dad3ba62ddcc0f687bdebe295126
Patch0:		no-opt.patch
URL:		http://caml.inria.fr/pub/old_caml_site/camlidl/
BuildRequires:	ocaml >= %{ocaml_ver}
Obsoletes:	ocaml-camlidl < 1.05-3
%requires_eq	ocaml-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Camlidl is a stub code generator for Objective Caml. It generates stub
code for interfacing Caml with C from an IDL description of the C
functions. Thus, Camlidl automates the most tedious task in
interfacing C libraries with Caml programs. It can also be used to
interface Caml programs with other languages, as long as those
languages have a well-defined C interface.

This package contains files needed to run bytecode executables using
this library.

%description -l pl.UTF-8
Camlidl jest generatorem kodu łączącego C z OCamlem. Pozwala on na
automatyczne tworzenie funkcji, które będą mogły być wywoływane z
OCamla na podstawie opisu IDL. Automatyzuje więc najbardziej
niewdzięczne aspekty odwoływania się do bibliotek napisanych w C z
OCamla. Może być również użyty do komunikacji z innymi językami, jeśli
tylko mają one dobrze zdefiniowany interfejs C.

Pakiet ten zawiera binaria potrzebne do uruchamiania programów
używających tej biblioteki.

%package devel
Summary:	IDL binding for OCaml - development part
Summary(pl.UTF-8):	Wiązania IDL dla OCamla - cześć programistyczna
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%requires_eq	ocaml

%description devel
Camlidl is a stub code generator for Objective Caml. It generates stub
code for interfacing Caml with C from an IDL description of the C
functions. Thus, Camlidl automates the most tedious task in
interfacing C libraries with Caml programs. It can also be used to
interface Caml programs with other languages, as long as those
languages have a well-defined C interface.

This package contains files needed to develop OCaml programs using
this library.

%description devel -l pl.UTF-8
Camlidl jest generatorem kodu łączącego C z OCamlem. Pozwala on na
automatyczne tworzenie funkcji, które będą mogły być wywoływane z
OCamla na podstawie opisu IDL. Automatyzuje więc najbardziej
niewdzięczne aspekty odwoływania się do bibliotek napisanych w C z
OCamla. Może być również użyty do komunikacji z innymi językami, jeśli
tylko mają one dobrze zdefiniowany interfejs C.

Pakiet ten zawiera pliki niezbędne do tworzenia programów używających
tej biblioteki.

%prep
%setup -q -a 1 -n camlidl-%{version}
%patch0 -p1

ln -s Makefile.unix config/Makefile

# NOTE: make opt to produce camlidl.opt won't work here, there is no such
# target even. That's bacause there is array.ml module in camlidl so
# it produces array.o and array.o is also in standard library. And C linker
# chokes.

%build
%{__make} -j1 -C compiler \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C lib com.cma %{?with_ocaml_opt:com.cmxa} \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C runtime \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C tools \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

ocamlmklib -o com lib/*.cm[xo] runtime/*.o

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir}/ocaml/idl,%{_includedir}/caml}
ln -sf ../../include/caml $RPM_BUILD_ROOT%{_libdir}/ocaml/caml

%{__make} install \
	%{!?with_ocaml_opt:NATIVELIB=""} \
	BINDIR=$RPM_BUILD_ROOT%{_bindir} \
	OCAMLLIB=$RPM_BUILD_ROOT%{_libdir}/ocaml

# fix install to subdir
%{__mv} $RPM_BUILD_ROOT%{_libdir}/ocaml/{*.{cm[ix],cma,a%{?with_ocaml_opt:,cmxa}},idl}

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs
install -p dll*.so $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -a tests/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
# remove Windows examples
%{__rm} -r $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/{comp,dispatch}

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib/camlidl
cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/site-lib/camlidl/META <<EOF
requires = ""
version = "%{version}"
directory = "+idl"
archive(byte) = "com.cma"
archive(native) = "com.cmxa"
linkopts = ""
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllcom.so

%files devel
%defattr(644,root,root,755)
%doc htmlman LICENSE README Changes
%attr(755,root,root) %{_bindir}/camlidl
%dir %{_libdir}/ocaml/idl
%{_libdir}/ocaml/idl/com.cma
%{_libdir}/ocaml/idl/com.cmi
%if %{with ocaml_opt}
%{_libdir}/ocaml/idl/com.a
%{_libdir}/ocaml/idl/com.cmxa
%endif
%{_libdir}/ocaml/idl/libcamlidl.a
%{_libdir}/ocaml/site-lib/camlidl
%{_libdir}/ocaml/caml
%{_includedir}/caml/camlidlruntime.h
%{_examplesdir}/%{name}-%{version}
%changelog
* Sun Jul 19 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-idl.git;a=log;h=master

* Sun Jul 19 2015 Jakub Bogusz <qboosh@pld-linux.org> 0f71ee8
- verbose files, release 11 (ocaml rebuild)

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> ace9ac3
- fixed install without opt

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> e1dabfa
- fixed no-opt patch
- rel 10

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> ff869cf
- added ocaml_opt patch
- rel 9

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 332177d
- rebuild with ocaml 4.02
- release 8 (by relup.sh)

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> 487fb0f
- merged changes from ocaml-camlidl; rel 7

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 703c2f1
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> eee7984
- converted to UTF-8

* Wed May 31 2006 Elan Ruusamäe <glen@pld-linux.org> e82b692
- rel 6 (rebuild with ocaml-3.09.2)

* Sun Apr 16 2006 Elan Ruusamäe <glen@pld-linux.org> 19f0f8e
- ocaml epoch is 1

* Sat Apr 15 2006 Elan Ruusamäe <glen@pld-linux.org> 4a13f6e
- ocaml 3.09.1

* Sat Dec 10 2005 Jan Rękorajski <baggins@pld-linux.org> d67f831
- release 3 for ocaml 3.09.0

* Tue Oct 11 2005 Sławomir Paszkiewicz <paszczus@pld-linux.org> 75373a1
- release up to rebuild with new ocaml

* Mon Oct 18 2004 Jakub Bogusz <qboosh@pld-linux.org> ebc0423
- unification

* Thu Sep 09 2004 kolodko <kolodko@pld-linux.org> a7094d7
- reduced rel to 1

* Wed Sep 08 2004 darekr <darekr@pld-linux.org> f24cc87
- updated to 1.05

* Fri Aug 27 2004 havner <havner@pld-linux.org> 1aa522b
- [mass commit], rel up for rebuild with ocaml

* Wed Sep 03 2003 Michal Moskal <michal@moskal.me> ab2dd12
- release 3 for ocaml 3.07

* Mon Aug 18 2003 Tomasz Pala <gotar@pld-linux.org> b81cfd4
- mass commit: cosmetics (removed trailing white spaces)

* Thu May 29 2003 Michal Moskal <michal@moskal.me> 0002521
- oops, rename in files too

